//*************************************************************
// Must pay attention to the boundary currently I preset them to be
// 0, 0 to 800, 600
// THus when apply it must take care about them
//*************************************************************

import java.io.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.BufferedImage;
import java.util.LinkedList; 
import java.util.StringTokenizer; 


public class gPanel extends JPanel
{
	BufferedImage 	bi;
	Graphics2D 		big;

	boolean 		firstTime 	= true;
	boolean 		calc 		= false;
	boolean 		firstloop;

	float 			boundingRectangleArea;
	float 			chArea = (float) 0.0;
	
	float           widthBound = 800;
	float           heightBound = 600;
	float           g_cEpsilon  = 2.0f;

	// the window size
	Rectangle 		area = new Rectangle();
	Rectangle 		boundingBox = new Rectangle();

	// create the lists for the points
	//*************************************************
	// Test point temporary variable
	//*************************************************
	//
	// I define the edge on the left of the cell as enter edge 
	//          the edge on the right of the cell as exit edge
	//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
	
	
	LinkedList 	ConvexHull 	 		= new LinkedList(); 	// For the created convex Hull, temporary for each iteration
	LinkedList 	PointsToTest		= new LinkedList();		// extra linked list for testing, temporary for each iteration
	LinkedList 	inputList 	 	 	= new LinkedList();		

	static LinkedList  GroupPoints  	 	= new LinkedList();	// For storing the ponts of group
	static LinkedList  GroupConvexHulls 	= new LinkedList();	// For storing the convexHulls
	static LinkedList  GroupPolygon     	= new LinkedList();	// For polygons
	static LinkedList  GroupDivisionEdge	= new LinkedList();	// For division edge for dividing into cells
	
	static LinkedList [] leaveEdge; // Those edges which current edges could use as exit
	static LinkedList [] enterEdge; // Those edges which could use current edges as exit
	
	int [] cellExit;			// The cell which this edge exit
	int [] cellEnter;			// The cell which this edge enter
	
	static LinkedList [] cellExitEdge; // All the exit edge for this cell
	static LinkedList [] cellEnterEdge;// All the enter edge for this cell

	static LinkedList [] cellConnection;// The cell connection relation Graph
	static int cellCount;
	
	static Polygon  [] GroupCell; 			// Cell polygon
	static LinkedList  [] GroupCellHull;	// Cell polygon vertices
	
	static Point2D.Float startLocation = new Point2D.Float(); // The starting location
	static Point2D.Float endLocation = new Point2D.Float();	  // The end location

	static LinkedList GroupPath	= new LinkedList();		// The cell path from start to end location
	static LinkedList GroupVertices = new LinkedList();	// The vertices of path from start to end location
	static boolean [] cellSearchFlag;					// Flag for controlling no-repeating search in path finding

	JButton jButtonClear 	= new JButton();			// Extra for clear all graph
	JButton jButtonCalc 	= new JButton();			// For calculation
	JCheckBox showNumbers 	= new JCheckBox("Toggle index numbers");// Toggle the index number

	public gPanel(){
		try	{
			jbInit();
		}
		catch(Exception e)	{
			e.printStackTrace();
		}
		// set the background color of the panel
		setBackground(Color.white);
		int w = (int)widthBound;  int h = (int)heightBound;
	}

	public static void main(String[] args){
		gPanel gPanel1 = new gPanel();
	}


	// user interface set up
	private void jbInit() throws Exception{
		// Add the mouse motion listener but currently do nothing
		this.addMouseMotionListener(new java.awt.event.MouseMotionAdapter(){});
		// Add the mouse click listener
		this.addMouseListener(new java.awt.event.MouseAdapter()	{
			public void mouseClicked(MouseEvent e)	{ 
				this_mouseClicked(e);
			}
		});
		// Add the clear button and its action
		jButtonClear.setText("Clear");
		jButtonClear.addActionListener(new java.awt.event.ActionListener()	{
			public void actionPerformed(ActionEvent e)	{
				jButtonClear_actionPerformed(e);
			}
		});
		this.add(jButtonClear, null);

		// Add the calculate button and its action
		jButtonCalc.setText("Calculate Convex hull");
		jButtonCalc.addActionListener(new java.awt.event.ActionListener(){
			public void actionPerformed(ActionEvent e){
				jButtonCalc_actionPerformed(e);
			}
		});
		this.add(jButtonCalc, null);

		showNumbers.addActionListener(new java.awt.event.ActionListener(){
			public void actionPerformed(ActionEvent e)	{
				showNumbers_actionPerformed(e);
			}
		});
		this.add(showNumbers, null);
	}

	// Print out the current information
	public void paintComponent(Graphics g)	{
		super.paintComponent(g);
		update(g);
	}

	public void update(Graphics g)	{
		Graphics2D 	g2 			= (Graphics2D)g;
		Dimension 	dim 		= getSize();
		int 		w 			= dim.width;
		int 		h 			= dim.height;
		
		area 					= new Rectangle(dim);
		Line2D.Float line 		= new Line2D.Float();

		if(firstTime)	{
			bi 	= (BufferedImage)createImage(w, h);	// Create the image butter
			big = bi.createGraphics();				// Create the graph
			big.setColor(Color.black);				// Set the color
			big.setStroke(new BasicStroke(1.0f));	// Set the stroke type
			big.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			firstTime = false;						// Turn off the first time flag
		}
		
		// clear screen
		big.setColor(Color.white);
		big.clearRect(0, 0, area.width, area.height);

		int indicator = 0;
		// draw all points in all groups
		for( int j = 0; j < GroupPoints.size(); j++)	{
			LinkedList ReadPoints = (LinkedList)GroupPoints.get(j);
			for(int k = 0; k < ReadPoints.size(); k++ )	{
				big.setPaint(Color.red); // Set the draw color be red
				// Draw the point
				big.fill(new Rectangle((int) ((Point2D.Float) ReadPoints.get(k)).x-2,(int) ((Point2D.Float) ReadPoints.get(k)).y-2, 4, 4));
				
				big.setPaint(Color.black);	// Set the draw color be black
				// show the index numbers of the points
				if (showNumbers.isSelected())
					big.drawString(Integer.toString(indicator), (int) ((Point2D.Float) ReadPoints.get(j)).x-4,(int) ((Point2D.Float) ReadPoints.get(j)).y-8);
				indicator++;	
			}// end of for k
		}// end of for j

		// if there is a calculated convexhull draw it
		if (calc)	{ 
			//*************************************************
			// Draw the barrier Hulls
			//*************************************************
			for(int j = 0; j < GroupConvexHulls.size(); j++){
				// Get the convex polygon out
				LinkedList convex = (LinkedList)GroupConvexHulls.get(j);
				for(int k = 0; k < (convex.size()) - 1; k++)	{

					// Set up the line for draw
					line.setLine((Point2D.Float) convex.get(k), (Point2D.Float) convex.get(k + 1));
					big.setColor(Color.blue);
					big.draw(line);
				} // end of for k
			}// end of for j
			//*************************************************
			// Draw the division edge
			//*************************************************
			for(int k = 0; k < GroupDivisionEdge.size(); k++)	{
				Line2D.Float edge = (Line2D.Float)GroupDivisionEdge.get(k);
				big.setColor(Color.green);
				big.draw(edge);
			}

			//*************************************************
			// Draw the cell boundary
			//*************************************************
			for(int k = 0; k < cellCount; k++)	{
				big.setColor(Color.green);
				big.draw(GroupCell[k]);
			}

			//*************************************************
			// Draw the start and end location
			//*************************************************
			// Draw the starting and ending position
			big.setPaint(Color.cyan); // Set the draw color be red
			big.fill(new Rectangle((int) startLocation.x - 2,(int) startLocation.y - 2, 4, 4));
			big.fill(new Rectangle((int) endLocation.x - 2,(int) endLocation.y - 2, 4, 4));
			
			//*************************************************
			// Draw the path
			//*************************************************
			for(int k = 0; k < GroupVertices.size() - 1; k++)	{
				Point2D.Float startP = (Point2D.Float)GroupVertices.get(k);
				Point2D.Float endP = (Point2D.Float)GroupVertices.get(k + 1);
				big.setColor(Color.orange);
				Line2D.Float edge = new Line2D.Float();
				edge.setLine(startP, endP);
				big.draw(edge);
			}
		}
		g2.drawImage(bi, 0, 0, this);
	}

	// Clear everything
	void jButtonClear_actionPerformed(ActionEvent e){
		calc 					= false;
		chArea 					= (float) 0.0;
		boundingRectangleArea 	= (float) 0.0;
		GroupPoints.clear();
		GroupConvexHulls.clear();
		repaint();
	}

	// Calculate the new converx voxel
	void jButtonCalc_actionPerformed(ActionEvent e)	{
		if (GroupPoints.size() > 0){
			initiate();
			calc 		= true;
			firstloop 	= true;
			repaint();// Repaint the graph
		}

	}

	void showNumbers_actionPerformed(ActionEvent e)	{
		repaint();
	}

	void this_mouseClicked(MouseEvent e){
		repaint();
	}

	void initiate(){
	
		// Clear all the convex hulls
		GroupConvexHulls.clear();	// The convex hull group
		GroupPolygon.clear();
		GroupDivisionEdge.clear();

		//***********************************************************
		// Create the convex hull for each group
		//***********************************************************
		for(int j = 0; j < GroupPoints.size(); j++)	{
			firstloop = true;			// Flag for controlling the loop
			ConvexHull.clear();		// Clear convex hull
			PointsToTest.clear();	// The test point
			Polygon convexPolygon 	= new Polygon();
			
			//=====================================================
			// Test using the getting directly from the GroupPoints
			//=====================================================
			LinkedList ReadPoints = (LinkedList)GroupPoints.get(j); // Get the points out
			for(int i = 0; i < ReadPoints.size(); i++)
				PointsToTest.add(ReadPoints.get(i));	// Remove smallest x point

			// SmallestPoint is always on ConvexHull, remove from list	
			ConvexHull.add(PointsToTest.remove(getSmallestPoint(ReadPoints))); 
			testPoints();			// Calculate the convex
			removeDuplicate();
			
			for(int k = 0; k < (ConvexHull.size()) - 1; k++)
				// Add point into the covexPolygon
				convexPolygon.addPoint((int) ((Point2D.Float) ConvexHull.get(k)).x, (int) ((Point2D.Float) ConvexHull.get(k)).y);
			
			GroupConvexHulls.add(new LinkedList(ConvexHull));
			GroupPolygon.add(convexPolygon);
		}// end of for j
		//********************************************************
		// Create the division edge for each vertices for trapezoidal decomposition
		//********************************************************
		findIntersection();
		//********************************************************
		// According to the devision edge create the cell and cell connection		
		//********************************************************
		createCellPolygon();
		
		//*********************************************************
		// Set up the start location and end location and should be able to set up by 
		// User interface and the following method should be able to change with the 
		// User interface
		//*********************************************************
		startLocation.setLocation(100.0f, 100.0f);
		endLocation.setLocation(500.0f, 500.0f);
		int startIndex = locateCell(startLocation);
		int endIndex = locateCell(endLocation);

//Debug print out		
//		System.out.println("start cell " + startIndex);
//		System.out.println("end cell " + endIndex);

		//*********************************************		
		// Create the cell connection from start to end
		//*********************************************		
		GroupPath.clear();
		cellSearchFlag = new boolean[cellCount];
		for(int i = 0; i < cellCount; i++)
			cellSearchFlag[i] = false;
		GroupPath = searchPath(startIndex, endIndex);
//Debug		
//		System.out.println("The path is");
//		for(int i = 0; i < GroupPath.size(); i++){
//			System.out.println("Node " + ((Integer)GroupPath.get(i)).toString());
//		}
		
		//*********************************************		
		// Create the cell path vertices from start to end
		//*********************************************		
		GroupVertices.clear();
		findPathPoint(startLocation, endLocation);
		
// Debug		
//		System.out.println("The Edges are");
//		for(int i = 0; i < GroupVertices.size(); i++){
//			System.out.println("\tVertices " + ((Point2D.Float)GroupVertices.get(i)).toString());
//		}
		
	}// end of initiate

	//*****************************************************************
	// Get the smallest x point out
	//*****************************************************************
	int getSmallestPoint(LinkedList ReadPoints){
		// Initialize the smallest x point
		float 	smallestx = ((Point2D.Float) ReadPoints.get(0)).x;
		int 	smallestPoint = 0;
		for(int i = 0; i < ReadPoints.size(); i++)	{
			if (((Point2D.Float) ReadPoints.get(i)).x < smallestx)	{
				smallestx = ((Point2D.Float) ReadPoints.get(i)).x;
				smallestPoint = i;
			}// end of if
		}// end of for
		return smallestPoint;
	}// end of function getSmallestPoint

	//***********************************************************
	// Calculate the determined of three points and I think this is for calculating the area
	//***********************************************************
	float calcDeterminant(Point2D.Float point1, Point2D.Float point2, Point2D.Float point3)
	{
		// This calculates the determinant of a 3 x 3 matrix with only one's in the third row 
		// If this determinant is positive point3 lie on the right side of the line through p1-p2
		// Remember that the origin in Java is in the upper left corner
		// (1/2 time the determinant is the area of the triangle)
		float a = point2.x * point3.y - point3.x * point2.y;
		float b = point1.x * point3.y - point3.x * point1.y;
		float c = point1.x * point2.y - point2.x * point1.y;
		float determinant = a - b + c;
		return determinant;	
	}

	//***********************************************************
	// Actual algorithm
	//***********************************************************
	void testPoints()
	{

		int PointsLeftSide 	= 0; // Points in the left side
		int PointsRightSide = 0; // Points in the right side
		int test = 0;

 		//Pick the last point (The first one is the smallest x)
		Point2D.Float ChLast 	  = (Point2D.Float) ConvexHull.getLast();
		Point2D.Float SecondPoint = (Point2D.Float) PointsToTest.removeLast();

		while (firstloop || (!((Point2D.Float)ConvexHull.getLast()).equals((Point2D.Float) ConvexHull.getFirst())))	{
			// Test the position of all points regarding to ChLast and SecondPoint
			for (int i = 0; i < PointsToTest.size();i++) {
				//Test the points
				if ((calcDeterminant(ChLast, SecondPoint, (Point2D.Float) PointsToTest.get(i))) >= 0) 
					//If true than the point is on the left side
					PointsLeftSide++; 
				else
					//If false then the point is on the right side
					PointsRightSide++; 
			}
			//If there are no points on the right side, add the secondpoint to CH
			if (PointsRightSide == 0) {
				ConvexHull.add(SecondPoint); 
				PointsToTest.addFirst(ConvexHull.getFirst()); //after adding a point on the hull, add the starting point to the testpointslist
				firstloop = false;
			}
			else // else put it back at the beginning of the testlist
				PointsToTest.addFirst(SecondPoint);
			testPoints(); // Recursion for the other points
		}
	}

	//*****************************************************************
	// Remove the duplicate point inside the convex hull
	//*****************************************************************
	void removeDuplicate()
	{
		for(int i = 0; i < ConvexHull.size(); i++)	{
			Point2D.Float sample = (Point2D.Float)ConvexHull.get(i);
			for(int j = i + 1; j < ConvexHull.size();){
				Point2D.Float test = (Point2D.Float)ConvexHull.get(j);
				if (sample.equals(test)){
					ConvexHull.remove(j);
				}
				else
					j++;
			} // end of for j
		}// end of for i
		Point2D.Float sample = (Point2D.Float)ConvexHull.get(0);
		ConvexHull.add(new Point2D.Float(sample.x, sample.y));
	}// end  of remove duplicate

	float calcConvexHullArea()
	{
		chArea = (float) 0.0;
		for(int i = 0; i < ConvexHull.size() - 2; i++)
			chArea = chArea + (float) 0.5 * calcDeterminant((Point2D.Float)ConvexHull.get(0), (Point2D.Float)ConvexHull.get(i+1),(Point2D.Float)ConvexHull.get(i+2));
		return chArea;
 	}

	//*********************************************************************
	// For each vertices create the division edge for trapezoidal decomposition
	//*********************************************************************
	void findIntersection()	{
		// Go through all all convex hulls
		for(int j = 0; j < GroupConvexHulls.size(); j++){
			// Get the polygon and corresponding convexhull out
			Polygon convexPolygon 	= (Polygon)GroupPolygon.get(j);
			LinkedList convex = (LinkedList)GroupConvexHulls.get(j);
			// Go through all vertices in this hull
			for(int k = 0; k < convex.size() - 1; k++)	{
				// Get the x, y position
				float x = ((Point2D.Float) convex.get(k)).x;
				float y = ((Point2D.Float) convex.get(k)).y;
				//**************************************************************
				// The lower side of vertex is not in valid polygon
				//**************************************************************
				if (!convexPolygon.contains( x,  y + g_cEpsilon))	{
				
					//*************************************************
					// Check the edge relation and make sure that we draw
					// In the right direction
					//***************************************************
					float xNext = ((Point2D.Float) convex.get(k + 1)).x;
					float yNext = ((Point2D.Float) convex.get(k + 1)).y;
					
					int index = k - 1;
					if(index < 0)
						index = convex.size() - 2;
						
					float xPrev = ((Point2D.Float) convex.get(index)).x;
					float yPrev = ((Point2D.Float) convex.get(index)).y;
					
					if ((xNext == x && yNext > y) || (xPrev == x && yPrev > y)){
						System.out.println("No go down because of down edge");
					}
					else{
//						System.out.println("Go down" + j);
						// Set up the intersect flag
						boolean intersectFlag = false;
						// Set up the line segment
						float xorigin = x;	// Set the rectange's left, up corner
						float yorigin = y;
						float worigin = 1;				 // Set the width to be one
						float horigin = heightBound - y; // Set the height
						float intersecty = heightBound;	 // The intersection y coordinate
						
						// Check the intersection with other polygon
						for(int l = 0; l < GroupPolygon.size(); l++){
							Line2D.Float line = new Line2D.Float();
							line.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, intersecty));

							//**********************************************
							// Find the intersection to other polygon
							//**********************************************
							if (l != j)	{
								Polygon intersectPoly = (Polygon)GroupPolygon.get(l);
								// Find whether the line segment and the polygon intersect or not
								if (intersectPoly.intersects(xorigin, yorigin, worigin, horigin)){ 
									// Intersect the polygon
									float temp = findPolyIntersection(l, line, true); 
									if (temp != 0)	{
										intersecty  = temp;
										horigin = intersecty - y;
										intersectFlag = true;
									}
								}// end of poly intersect with other polygon
							}// The polygon is convex and thus it never self intersect
						}// end of for
						
						// There is some intersection between this line and other polygon
						if (intersectFlag)	{
							Line2D.Float edge = new Line2D.Float();
							edge.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, intersecty));
							GroupDivisionEdge.add(edge);	
						}// end of if

						// No intersection
						else{
							Line2D.Float edge = new Line2D.Float();
							edge.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, heightBound));
							GroupDivisionEdge.add(edge);	
						}// end of else
					}// end of else
				}// end of if poly
				//**************************************************************
				// The upper side of vertex is not in valid polygon
				//**************************************************************
				if (!convexPolygon.contains( (double)x, (double)y - g_cEpsilon)){

					//*************************************************
					// Check the edge relation and make sure that we draw
					// In the right direction
					//***************************************************
					float xNext = ((Point2D.Float) convex.get(k + 1)).x;
					float yNext = ((Point2D.Float) convex.get(k + 1)).y;
					
					int index = k - 1;
					if(index < 0)
						index = convex.size() - 2;
						
					float xPrev = ((Point2D.Float) convex.get(index)).x;
					float yPrev = ((Point2D.Float) convex.get(index)).y;
					
					if ((xNext == x && yNext < y) || (xPrev == x && yPrev < y)){
						System.out.println("No go up because of up edge");
					}

					else{
						System.out.println("Go up" + j);
						float xorigin = x;
						float yorigin = 0;
						float worigin = 1;
						float horigin = y;
						
						boolean intersectFlag = false;
						float intersecty = 0;	 // The intersection y coordinate

						//*********************************************
						// Check the intersection with other polygon
						//*********************************************
						for(int l = 0; l < GroupPolygon.size(); l++){
							Line2D.Float line = new Line2D.Float();
							line.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, intersecty));

							// Find the intersection point between polygon
							if (l != j)	{
								Polygon intersectPoly = (Polygon)GroupPolygon.get(l);
								// Find whether the line segment and the polygon intersect or not
								if (intersectPoly.intersects(xorigin, yorigin, worigin, horigin)){ 
									// Create the line segment for the line segment
									float temp = findPolyIntersection(l, line, false);
									if (temp != 0)	{
										intersecty   = temp;
										yorigin = intersecty;
										horigin = y - intersecty;
										intersectFlag = true;
									}
									
								}// end of poly intersect with other polygon
							
							}// The polygon is convex and thus it never self intersect
						}// end of for l
						
						// There is some intersection between
						if (intersectFlag)	{
							Line2D.Float edge = new Line2D.Float();
							edge.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, intersecty));
							GroupDivisionEdge.add(edge);	
						}// end of if
						// No intersection
						else{
							Line2D.Float edge = new Line2D.Float();
							edge.setLine((Point2D.Float) convex.get(k), new Point2D.Float(x, 0));
							GroupDivisionEdge.add(edge);	
						}// end of else
					}// end of else
				}// end of if up
			} // end of for k
		}// end of for j
		
		// Create the linked cell
		createCell();
	}// end of intersectoin

	//******************************************************************************
	// Find the intersection point between line segment and polygon
	//******************************************************************************	
	float findPolyIntersection(int hullIndex, Line2D.Float line, boolean downFlag){
		boolean  intersectFlag = false;
	
		// The ray is going down in screen direction
		if (downFlag)	{
			// Set the ymin to heightBound
			float ymin = heightBound;
			// Get the convex polygon out
			LinkedList convex = (LinkedList)GroupConvexHulls.get(hullIndex);
			// Intersect all line segment
			for(int i = 0; i < convex.size() - 1; i++)	{
				// Create the polygon edge
				Line2D.Float edge = new Line2D.Float();
				edge.setLine((Point2D.Float) convex.get(i), (Point2D.Float) convex.get(i + 1));
				// Check whether the polygon intersect or not
				if (line.intersectsLine(edge))	{
					intersectFlag = true;
					
					// Find the intersection
					float x1 = ((Point2D.Float) convex.get(i)).x;
					float y1 = ((Point2D.Float) convex.get(i)).y;
					float x2 = ((Point2D.Float) convex.get(i + 1)).x;
					float y2 = ((Point2D.Float) convex.get(i + 1)).y;
					float xInter = ((Point2D.Float) line.getP1()).x;
					float yInter = y1 + (y2 - y1) * (xInter - x1) / (x2 - x1);
					if(yInter < ymin)
						ymin = yInter;
				}// end of if
			}// end of for
			if(intersectFlag)
				return ymin;
			else
				return 0.0f;	
		}// end of if
		else{
			// Set the maximum to zero
			float ymax = 0;
			// Get the polygon out
			LinkedList convex = (LinkedList)GroupConvexHulls.get(hullIndex);
			for(int i = 0; i < convex.size() - 1; i++)	{
				// Get the edge of each polygon
				Line2D.Float edge = new Line2D.Float();
				edge.setLine((Point2D.Float) convex.get(i), (Point2D.Float) convex.get(i + 1));
				// Check the intersection
				if (line.intersectsLine(edge))	{
					intersectFlag = true;
					// Find the intersection
					float x1 = ((Point2D.Float) convex.get(i)).x;
					float y1 = ((Point2D.Float) convex.get(i)).y;
					float x2 = ((Point2D.Float) convex.get(i + 1)).x;
					float y2 = ((Point2D.Float) convex.get(i + 1)).y;
					float xInter = ((Point2D.Float) line.getP1()).x;
					float yInter = y1 + (y2 - y1) * (xInter - x1) / (x2 - x1);
					if(yInter > ymax)
						ymax = yInter;
				}// end of if
			}// end of for
			if(intersectFlag)
				return ymax;
			else
				return 0.0f;	
		}// end of if
	} // end of intersect
	
	//************************************************************
	// create the cell and cell connection information
	//************************************************************
	void createCell(){
	
		//*********************************************************
		// Sorting if we have other algorithm we should use it
		// I used the insertion sort and should be modified
		//**********************************************************
		LinkedList  GroupOrderEdge	= new LinkedList();
		// Remove the first two elements and put them in order
		Line2D.Float first = (Line2D.Float)GroupDivisionEdge.removeFirst();
		Line2D.Float second = (Line2D.Float)GroupDivisionEdge.removeFirst();
		// Insert the first two edge
		if (((Point2D.Float) first.getP1()).x >= ((Point2D.Float) second.getP1()).x)	{
			GroupOrderEdge.add(second);
			GroupOrderEdge.add(first);
		}
		else{
			GroupOrderEdge.add(first);
			GroupOrderEdge.add(second);
		}
		// Insert all left edge into proper position
		int totalSize = GroupDivisionEdge.size();
		for(int i = 0; i < totalSize; i++){
			Line2D.Float insert = (Line2D.Float)GroupDivisionEdge.removeFirst();
			int j;
			for(j = 0; j < GroupOrderEdge.size(); j++){
				Line2D.Float test = (Line2D.Float)GroupOrderEdge.get(j);
				if(((Point2D.Float) test.getP1()).x >= ((Point2D.Float) insert.getP1()).x)
					break;
			}
			GroupOrderEdge.add(j, insert);
		}
		for(int i = 0; i < GroupOrderEdge.size(); i++){
			Line2D.Float printNode = (Line2D.Float)GroupOrderEdge.get(i);
			System.out.println("The node " + (printNode.getP1()).toString());
		}
		
		// Reinsert the Group Division edge
		GroupDivisionEdge.clear();
		GroupDivisionEdge.addAll(GroupOrderEdge);
		
		// Also insert the boundary first
		Line2D.Float insertFirst = new Line2D.Float();
		insertFirst.setLine(0, 0, 0, heightBound);
		GroupDivisionEdge.addFirst(insertFirst);
		GroupOrderEdge.addFirst(insertFirst);
		// Also insert the boundary last edge
		Line2D.Float insertLast = new Line2D.Float();
		insertLast.setLine(widthBound - 1, 0, widthBound - 1, heightBound);
		GroupDivisionEdge.add(insertLast);
		GroupOrderEdge.add(insertLast);

		//**************************************************
		// Create memory space all global variable
		//**************************************************
		leaveEdge = new LinkedList[GroupDivisionEdge.size()];
		enterEdge = new LinkedList[GroupDivisionEdge.size()];
		cellExit = new int[GroupDivisionEdge.size()];
		cellEnter = new int[GroupDivisionEdge.size()];
		cellExitEdge = new LinkedList[GroupDivisionEdge.size()];
		cellEnterEdge = new LinkedList[GroupDivisionEdge.size()];
		cellConnection = new LinkedList[GroupDivisionEdge.size()];
		for(int i = 0; i < GroupDivisionEdge.size(); i++){
			enterEdge[i] = new LinkedList();
			cellExitEdge[i] = new LinkedList();
			cellEnterEdge[i] = new LinkedList();
			cellConnection[i] = new LinkedList();
			cellExit[i] = -1;
			cellEnter[i] = -1;
		}

//		System.out.println("The order edge" + GroupOrderEdge.size());



	//**************************************************
	// Find the leaveEdge information for each edge
	//**************************************************
		//*******************************************
		// Find each edge's nearest edge which will be its leave edge
		//*******************************************
		for(int i = 1; i < GroupOrderEdge.size() - 1; i++){
			Line2D.Float node = (Line2D.Float)GroupOrderEdge.get(i);// the starting test edge
			Point2D.Float start = (Point2D.Float)node.getP1();// the start point of this edge
			Point2D.Float end   = (Point2D.Float)node.getP2();// the end point of this edge
			Line2D.Float nodeStart = new Line2D.Float();	// edge is nearest to this test edge from start vertex
			Line2D.Float nodeEnd = new Line2D.Float();// edge is nearest to this test edge from end vertex
			Point2D.Float startNearest = new Point2D.Float(); // The nearest vertex to start vertex
			Point2D.Float endNearest = new Point2D.Float(); // The nearest vertex to end vertex
			boolean endFlag = false;	// control flag
			boolean startFlag = false;	// control flag
			int endIndex = 0;
			int startIndex = 0;
			
//			System.out.println("The check vertex " + start.toString() + i); 
			//*****************************************************
			// Find the nearest edge of the end point of current division edge
			//*****************************************************
			if (end.y <= g_cEpsilon || end.y >= (heightBound - g_cEpsilon))	{
				for(int j = i + 1; j < GroupOrderEdge.size(); j++)	{
					nodeEnd = (Line2D.Float)GroupOrderEdge.get(j);
					if (((Point2D.Float)nodeEnd.getP2()).y == end.y){
						endIndex = j;
						endFlag = true;
						break;
					}
				}
				if (!endFlag){
					endFlag = true;
					nodeEnd = (Line2D.Float)GroupOrderEdge.getLast();
					endIndex = GroupOrderEdge.size() - 1;
				}
			}
			// Find the nearest edge
			else{
				Line2D.Float intersectEdge = new Line2D.Float();	// The checking edge
				Point2D.Float startVertex = new Point2D.Float();	// The checking edge vertex
				Point2D.Float endVertex = new Point2D.Float();		// The checking edge end vertex
				float checkx = end.x - g_cEpsilon / 2.0f;			// For checking small region
				float checky = end.y - g_cEpsilon / 2.0f;
				boolean findFlag = false;							// Flag for whetehr we have found the edge
				// Go through all convex hull
				for(int j = 0; j < GroupConvexHulls.size(); j++){
					// Get the polygon and corresponding convexhull out
					LinkedList convex = (LinkedList)GroupConvexHulls.get(j);
					// Go through all vertices in this hull
					for(int k = 0; k < convex.size() - 1; k++)	{
						// Create the edge in the convex hull
						startVertex =(Point2D.Float) convex.get(k);
						endVertex 	=(Point2D.Float) convex.get(k + 1);
						intersectEdge.setLine(startVertex, endVertex);
						//?????????????????????????????????????????????
						// Problem for vertical
						//?????????????????????????????????????????????
						// Check whether the point is in the edge
						if(intersectEdge.intersects(checkx, checky, g_cEpsilon, g_cEpsilon)){
/*							if (startVertex.x > endVertex.x && abs(x - startVertex.x) < g_cEpsilon )
								continue;
							else if(startVertex.x < endVertex.x && abs(x - endVertex.x) < g_cEpsilon)
								continue;*/
							
							findFlag = true;
							break;
						}
					}
					if(findFlag)
						break;
				}// end of for j
				//***********************************************
				// Find the nearest edge
				//***********************************************
				if (findFlag){
//					System.out.println("The end edge start " + startVertex.toString());
//					System.out.println("The end edge end " + endVertex.toString());
					endFlag = false;
					// Create the edge of the two vertex
					for(int j = i + 1; j < GroupOrderEdge.size(); j++)	{
						// Get the nearest edge out
						Line2D.Float edgeTest = (Line2D.Float)GroupOrderEdge.get(j);
						// Get the start point of the edge
						Point2D.Float test = (Point2D.Float)edgeTest.getP1();
						
						// The edge vertex is the starting point of this edge
						if(startVertex.equals(test) || endVertex.equals(test)) {
							Point2D.Float testEnd   = (Point2D.Float)edgeTest.getP2();
							Point2D.Float testStart = (Point2D.Float)edgeTest.getP1();
//							System.out.println("Execute the check of vertex");
							if (start.y < end.y){
								if (testEnd.y < testStart.y)	{
									nodeEnd = edgeTest;
									endFlag = true;
									endIndex = j;
									break;
								}
							}
							else{
								if (testEnd.y > testStart.y)	{
									nodeEnd = edgeTest;
									endFlag = true;
									endIndex = j;
									break;
								}
							}// end of else
						}// end of vertex tex
						
						// The end point is on this edge
						Point2D.Float testPoint = (Point2D.Float)edgeTest.getP2();
						float startx = (testPoint.x - g_cEpsilon / 2.0f);
						float starty = (testPoint.y - g_cEpsilon / 2.0f);
						if (intersectEdge.intersects(startx, starty, g_cEpsilon, g_cEpsilon)){
							nodeEnd = edgeTest;
							endFlag = true;
							endIndex = j;
							break;
						}// end of if intersectEdge
					}// end of for j
				}// end of if find flag
				if (!endFlag) {
					endFlag = true;
					nodeEnd = (Line2D.Float)GroupOrderEdge.getLast();
					endIndex = GroupOrderEdge.size() - 1;
				}
//				System.out.println("The end edge start " + ((Point2D.Float)nodeEnd.getP1()).toString());
//				System.out.println("The end edge end " + ((Point2D.Float)nodeEnd.getP2()).toString());
			}// end of else

			//*********************************************************
			// For nearest edge from the starting point
			//*********************************************************
			for(int j = 0; j < GroupConvexHulls.size(); j++){
				boolean vertexFlag = false;// For control whether we find the vertex or not

				// Get the polygon and corresponding convexhull out
				Polygon convexPolygon 	= (Polygon)GroupPolygon.get(j);
				LinkedList convex = (LinkedList)GroupConvexHulls.get(j);
				// Go through all vertices in this hull
				for(int k = 0; k < convex.size() - 1; k++)	{
					// Check the vertex is equal to the satrt vertex
					Point2D.Float vertex = (Point2D.Float)convex.get(k);
					if (vertex.equals(start)){
						vertexFlag = true; // set up the flag
						
						// Get the nearest two vertex arround
						Point2D.Float nearest1 = (Point2D.Float)convex.get(k + 1);
						int index = k - 1;
						if(index < 0)
							index = convex.size() - 2;
						Point2D.Float nearest2 = (Point2D.Float)convex.get(index);
						
						// All the nearest vertex is in the left size of current vertex
						if (start.x > nearest1.x && start.x > nearest2.x){
							startFlag = false;
							break;
						}
						// two neighbor is one in left and the other is in right
						else if ( start.x > nearest1.x && start.x < nearest2.x)	{
							startNearest = nearest2;
							startFlag = true;
						}	
						else if ( start.x < nearest1.x && start.x > nearest2.x)	{
							startNearest = nearest1;
							startFlag = true;
						}
						//	both are on the right side
						else if ( start.x <= nearest1.x && start.x <= nearest2.x)	{
							// The edge is going down
							if (end.y > start.y){
								if(nearest1.y > nearest2.y)
									startNearest = nearest1;
								else
									startNearest = nearest2;	
							}
							// The edge is going up
							else{
								if(nearest1.y > nearest2.y)
									startNearest = nearest2;
								else
									startNearest = nearest1;	
							}
							startFlag = true;
						}// end of else if
						break;
					}// end of if
				}// end of for k
				if(vertexFlag)// find the vertex in this hull polygon
					break;
			}// end of for j
			// Find the nearest point
			if (startFlag){
				startFlag = false;
				Line2D.Float startEdge = new Line2D.Float();
//				System.out.println("The startnearest " + startNearest.toString());
				startEdge.setLine(start, startNearest);
				// Create the edge of the two vertex
				for(int j = i + 1; j < GroupOrderEdge.size(); j++)	{
					// Get the nearest edge out
					Line2D.Float edgeTest = (Line2D.Float)GroupOrderEdge.get(j);
					// Get the start point of the edge
					Point2D.Float test = (Point2D.Float)edgeTest.getP1();
					// The same edge point as the vertex
					if(startNearest.equals(test)) {
						Point2D.Float testEnd = (Point2D.Float)edgeTest.getP2();
						Point2D.Float testStart = (Point2D.Float)edgeTest.getP1();
//						System.out.println("Execute the check of vertex");
						if (start.y < end.y){
							if (testEnd.y > testStart.y)	{
								nodeStart = edgeTest;
								startFlag = true;
								startIndex = j;
								break;
							}
						}
						else{
							if (testEnd.y < testStart.y)	{
								nodeStart = edgeTest;
								startFlag = true;
								startIndex = j;
								break;
							}
						}
					}
					// The end point is on this edge
					Point2D.Float testPoint = (Point2D.Float)edgeTest.getP2();
					float startx = (testPoint.x - g_cEpsilon / 2.0f);
					float starty = (testPoint.y - g_cEpsilon / 2.0f);
					if (startEdge.intersects(startx, starty, g_cEpsilon, g_cEpsilon)){
						nodeStart = edgeTest;
						startFlag = true;
						startIndex = j;
						break;
					}
				}
			}// end of if start flag
			if (!startFlag)	{
				nodeStart = (Line2D.Float)GroupOrderEdge.getLast();
				startIndex = GroupOrderEdge.size() - 1;
				startFlag = true;
			}

// Debug			
//			System.out.println("The start edge " + startIndex);
//			System.out.println("The end edge " + endIndex);
//			System.out.println("The start edge start " + ((Point2D.Float)nodeStart.getP1()).toString());
//			System.out.println("The start edge end " + ((Point2D.Float)nodeStart.getP2()).toString());
//			System.out.println("The end edge start " + ((Point2D.Float)nodeEnd.getP1()).toString());
//			System.out.println("The end edge end " + ((Point2D.Float)nodeEnd.getP2()).toString());

			// According to the edge get from the nearest starting and ending edge we
			// could determine there are one, two, or more exit edges
			
			if (startIndex == endIndex)	{// single exit edge
				LinkedList connectedEdge = new LinkedList();
				connectedEdge.add(new Integer(startIndex));
				leaveEdge[i] = connectedEdge;
//				System.out.println("Insert into the same");
			}	
			else if (startIndex == GroupOrderEdge.size() - 1){// single exit edge
				LinkedList connectedEdge = new LinkedList();
				connectedEdge.add(new Integer(endIndex));
				leaveEdge[i] = connectedEdge;
//				System.out.println("Insert: start");
			}
			else if (startIndex == GroupOrderEdge.size() - 1){// single exit edge
				LinkedList connectedEdge = new LinkedList();
				connectedEdge.add(new Integer(endIndex));
				leaveEdge[i] = connectedEdge;
//				System.out.println("Insert: end");
			}
			else{// multiple exit edge
//				System.out.println("Insert: different");
				LinkedList connectedEdge = new LinkedList();
				connectedEdge.add(new Integer(startIndex));
				connectedEdge.add(new Integer(endIndex));

				// Find other intermediate edge
				float upBoundStart;
				float lowBoundStart;
				float upBoundEnd;
				float lowBoundEnd;
				float upBound;
				float lowBound;
				
				// Get the upper bound and low bound of start
				if (((Point2D.Float)nodeStart.getP1()).y > ((Point2D.Float)nodeStart.getP2()).y){
					upBoundStart = ((Point2D.Float)nodeStart.getP1()).y;
					lowBoundStart = ((Point2D.Float)nodeStart.getP2()).y;
				}
				else{
					upBoundStart = ((Point2D.Float)nodeStart.getP2()).y;
					lowBoundStart = ((Point2D.Float)nodeStart.getP1()).y;
				}

				// Get the upper bound and low bound of end
				if (((Point2D.Float)nodeEnd.getP1()).y > ((Point2D.Float)nodeEnd.getP2()).y){
					upBoundEnd = ((Point2D.Float)nodeEnd.getP1()).y;
					lowBoundEnd = ((Point2D.Float)nodeEnd.getP2()).y;
				}
				else{
					upBoundEnd = ((Point2D.Float)nodeEnd.getP2()).y;
					lowBoundEnd = ((Point2D.Float)nodeEnd.getP1()).y;
				}
				
				// set up the real bound
				if (upBoundEnd == lowBoundStart || lowBoundEnd == upBoundStart)	{
					leaveEdge[i] = connectedEdge;
				}
				else {
					if (upBoundEnd > upBoundStart){
						upBound = lowBoundEnd;
						lowBound = upBoundStart;
					}
					else{
						upBound = lowBoundStart;
						lowBound = upBoundEnd;
					}
					
					for(int j = i + 1; j < GroupOrderEdge.size() - 1; j++)	{
						// Find the same index as start and endIndex
						if(j == startIndex || j == endIndex)
							continue;			
						// The edge for check if its x is smaller than current index going to next	
						// if its x is bigger than current index break and jump out
						Line2D.Float checkEdge = (Line2D.Float) GroupOrderEdge.get(j);	
						if(((Point2D.Float)nodeEnd.getP1()).x > ((Point2D.Float)checkEdge.getP1()).x)
							continue;
						if(((Point2D.Float)nodeEnd.getP1()).x < ((Point2D.Float)checkEdge.getP1()).x) 
							break;
							
						if (((Point2D.Float)checkEdge.getP1()).y <= upBound &&
							((Point2D.Float)checkEdge.getP2()).y <= upBound &&
							((Point2D.Float)checkEdge.getP1()).y >= lowBound &&
							((Point2D.Float)checkEdge.getP2()).y >= lowBound)
							connectedEdge.add(new Integer(j));
							
					}// end of for j
					leaveEdge[i] = connectedEdge;
				}// end of else
			}// end of else
//		System.out.println("The output edge start " + ((Point2D.Float)nodeStart.getP1()).toString());
//		System.out.println("The output edge end " + ((Point2D.Float)nodeStart.getP2()).toString());*/
		}// end of for

		//**********************************************************
		// Create the each edge enter and leave situation
		//*******************************************************
		for(int i = 1; i < GroupOrderEdge.size() - 1; i++)	{
			System.out.println("edge " + i);
			LinkedList indexList = leaveEdge[i];
			for(int j = 0; j < indexList.size(); j++)	{
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				enterEdge[edgeIndex].add(new Integer(i));
//				System.out.println("\tedge " + ((Integer)indexList.get(j)).toString());
			}
		}
		
		for(int i = 1; i < GroupOrderEdge.size(); i++)	{
//			System.out.println("Enter edge " + i);
			LinkedList indexList = enterEdge[i];
//			for(int j = 0; j < indexList.size(); j++)	{
//				System.out.println("\tEnter edge " + ((Integer)indexList.get(j)).toString());
//			}
		}

		//**********************************************************
		// Create the cell's exit edge information
		//*******************************************************
		cellCount = 0;
		LinkedList operationList = new LinkedList();
		
		// Put in the first few leaving edge for starting cell
		Line2D.Float firstEdge = (Line2D.Float)GroupOrderEdge.get(1);
		float xTest = ((Point2D.Float)firstEdge.getP1()).x;
		// Put in the first node into the list
		operationList.add(new Integer(1));
		cellExit[1] = cellCount;
		cellExitEdge[cellCount].add(new Integer(1));
		for(int i = 2; i < GroupOrderEdge.size(); i++)	{
			firstEdge = (Line2D.Float)GroupOrderEdge.get(i);
			if (xTest == ((Point2D.Float)firstEdge.getP1()).x){
				operationList.add(new Integer(i));
				cellExit[i] = cellCount;
				cellExitEdge[cellCount].add(new Integer(i));
			}
			else
				break;	
		}
//		for(int i = 0; i < operationList.size(); i++) {
//			System.out.println("in desk " + ((Integer)operationList.get(i)).toString());
//		}
	
		//*******************************************************
		// Go through all edge
		//******************************************************
		for(cellCount = 1; operationList.size() > 0;){
			int cellIndex = cellCount;	// For the real cell index
			boolean cellExistFlag = false;
			
			// Get the current index of the operation list
			int currentEdgeIndex = ((Integer)operationList.removeFirst()).intValue();
			
			if(currentEdgeIndex == GroupOrderEdge.size() -1)
				continue;
				
			// Extract the out edge for this edge
			LinkedList indexList = leaveEdge[currentEdgeIndex];
			for(int j = 0; j < indexList.size(); j++)	{
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				// The cell has been already referred to 
				if (cellExit[edgeIndex] != -1)	{
					cellExistFlag = true;
					cellIndex = cellExit[edgeIndex];
					break;
				}
			}
			if (!cellExistFlag)	
				cellCount++;
			else
				continue;	
			// Put all the edge into responsible position		
			for(int j = 0; j < indexList.size(); j++)	{
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				operationList.add(new Integer(edgeIndex));
				cellExit[edgeIndex] = cellIndex;
				cellExitEdge[cellIndex].add(new Integer(edgeIndex));
			}

//			System.out.println("Round");
//			for(int i = 0; i < operationList.size(); i++) {
//					System.out.println("in desk " + ((Integer)operationList.get(i)).toString());
//			}
		}// end of for cell Count
//		System.out.println("The edge's cell information");
//		for(int i = 1; i < GroupOrderEdge.size(); i++){
//			System.out.println("Cell " + cellExit[i]);
//		}
		//********************************************************
		// Create cell entering information
		//*******************************************************
//		System.out.println("The cell exit edge information");
		for(int i = 0; i < cellCount; i++){
//			System.out.println("Cell " + i);
			LinkedList indexList = (LinkedList)cellExitEdge[i];
			for(int j = 0; j < indexList.size(); j++){
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				LinkedList enterList = enterEdge[edgeIndex];
//				System.out.println("\tEdge " + edgeIndex);
				for(int k = 0; k < enterList.size(); k++){
					int enterEdgeIndex = ((Integer)enterList.get(k)).intValue();
					Integer insertTerm = new Integer(enterEdgeIndex);
					if(cellEnterEdge[i].contains(insertTerm))
						continue;
					else{
						cellEnterEdge[i].add(insertTerm);
						cellEnter[enterEdgeIndex] = i;
					}
				}
			}
		}
		
//		System.out.println("The edge's enter cell information");
//		for(int i = 1; i < GroupOrderEdge.size(); i++){
//			System.out.println("Cell " + cellEnter[i]);
//		}
		
//		System.out.println("The cell enter edge information");
		for(int i = 0; i < cellCount; i++){
//			System.out.println("Cell " + i);
			LinkedList indexList = (LinkedList)cellEnterEdge[i];
			for(int j = 0; j < indexList.size(); j++){
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
//				System.out.println("\tEdge " + edgeIndex);
			}
		}
		
		// Connect the cell
		for(int i = 0; i < cellCount; i++){
			LinkedList indexList = (LinkedList)cellEnterEdge[i];
			for(int j = 0; j < indexList.size(); j++){
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				int cellIndex = cellExit[edgeIndex];
				Integer insertItem = new Integer(cellIndex);
				if(cellConnection[i].contains(insertItem) || cellIndex < 0)
					continue;
				else
					cellConnection[i].add(insertItem);	
			}// end of for j
			
			indexList = (LinkedList)cellExitEdge[i];
			for(int j = 0; j < indexList.size(); j++){
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				int cellIndex = cellEnter[edgeIndex];
				Integer insertItem = new Integer(cellIndex);
				if(cellConnection[i].contains(insertItem) || cellIndex < 0)
					continue;
				else
					cellConnection[i].add(insertItem);	
			}// end of for j

		}// end of for i
		System.out.println("The cell connection");
		for(int i = 0; i < cellCount; i++){
			System.out.println("Cell " + i);
			LinkedList indexList = (LinkedList)cellConnection[i];
			for(int j = 0; j < indexList.size(); j++)
				System.out.println("\tCell " + ((Integer)indexList.get(j)).toString());
		}// end of for i
	}// end of function

	//*************************************************************
	// According the enter and exit edge information create each cell
	// For starting point searching
	//*************************************************************

	void createCellPolygon(){
		GroupCell = new Polygon[cellCount]			; // Cell polygon
		GroupCellHull = new LinkedList[cellCount]	; // Cell polygon vertices
		
		for(int i = 0; i < cellCount; i++){
			GroupCellHull[i] = new LinkedList();
			GroupCell[i] = new Polygon();
		}
		
		// Go through all cell		
		for(int i = 0; i < cellCount; i++){
			float xEnter = 0, yEnterUp = 0, yEnterDown = heightBound;
			float xExit = 0, yExitUp = 0, yExitDown = heightBound;
			LinkedList currentPoints = new LinkedList();
			if (i == 0)	{
				xEnter = 0;
				yEnterUp = 0;
				yEnterDown = heightBound;
			}
			else{
				yEnterUp = heightBound;
				yEnterDown = 0;
				
				LinkedList indexList = (LinkedList)cellEnterEdge[i];
				for(int j = 0; j < indexList.size(); j++){
					int edgeIndex = ((Integer)indexList.get(j)).intValue();
					Line2D.Float edge = (Line2D.Float) GroupDivisionEdge.get(edgeIndex);
					float x1 = ((Point2D.Float)edge.getP1()).x;
					float y1 = ((Point2D.Float)edge.getP1()).y;
					float y2 = ((Point2D.Float)edge.getP2()).y;
					float yUp;
					float yDown;
					if (y1 > y2) {
						yDown = y1;
						yUp   = y2;
					}
					else	{
						yDown = y2;
						yUp   = y1;
					}
									
					xEnter = x1;
					if(yEnterUp > yUp)
						yEnterUp = yUp;
					if(yEnterDown < yDown)
						yEnterDown = yDown;	
				}// end of for j
			}
			
//			System.out.println("Cell " + i);
//			System.out.println("Enter x" + xEnter);
//			System.out.println("Enter up" + yEnterUp);
//			System.out.println("Enter down" + yEnterDown);
			
			yExitUp = heightBound;
			yExitDown = 0;
			
			LinkedList indexList = (LinkedList)cellExitEdge[i];
			for(int j = 0; j < indexList.size(); j++){
				int edgeIndex = ((Integer)indexList.get(j)).intValue();
				Line2D.Float edge = (Line2D.Float) GroupDivisionEdge.get(edgeIndex);
				float x1 = ((Point2D.Float)edge.getP1()).x;
				float y1 = ((Point2D.Float)edge.getP1()).y;
				float y2 = ((Point2D.Float)edge.getP2()).y;
				float yUp;
				float yDown;
				if (y1 > y2) {
					yDown = y1;
					yUp   = y2;
				}
				else	{
					yDown = y2;
					yUp   = y1;
				}
								
				xExit = x1;
				if(yExitUp > yUp)
					yExitUp = yUp;
				if(yExitDown < yDown)
					yExitDown = yDown;	
			}// end of for j
//			System.out.println("Exit x" + xExit);
//			System.out.println("Exit up" + yExitUp);
//			System.out.println("Exit down" + yExitDown);
			
			GroupCellHull[i].add(new Point2D.Float(xEnter, yEnterUp));
			GroupCellHull[i].add(new Point2D.Float(xExit, yExitUp));
			GroupCellHull[i].add(new Point2D.Float(xExit, yExitDown));
			GroupCellHull[i].add(new Point2D.Float(xEnter, yEnterDown));
			GroupCellHull[i].add(new Point2D.Float(xEnter, yEnterUp));

			GroupCell[i].addPoint((int)xEnter, (int)yEnterUp);
			GroupCell[i].addPoint((int)xExit, (int)yExitUp);
			GroupCell[i].addPoint((int)xExit, (int)yExitDown);
			GroupCell[i].addPoint((int)xEnter, (int)yEnterDown);
		
		}// end of for i
	}

	//*************************************************************
	// According to the location determine which cell it belong to	
	//*************************************************************
	int locateCell(Point2D.Float location){
		for(int i = 0; i < cellCount; i++)	{
			if(GroupCell[i].contains(location.x, location.y))
				return i;
		}
		return -1;
		
	}

	//*************************************************************
	// Recursively breath searching
	//*************************************************************
	LinkedList searchPath(int startIndex, int endIndex){
		LinkedList linkCell = cellConnection[startIndex];
		LinkedList returnList;
		int cellIndex;
		cellSearchFlag[startIndex] = true;
		
		for(int i = 0; i < linkCell.size(); i++){
			cellIndex = ((Integer)linkCell.get(i)).intValue();
			if (cellIndex == endIndex)	{
				returnList = new LinkedList();
				returnList.add(new Integer(startIndex));
				returnList.add(new Integer(cellIndex));
				return returnList;
			}
		}
		
		for(int i = 0; i < linkCell.size(); i++){
			cellIndex = ((Integer)linkCell.get(i)).intValue();
			if(!cellSearchFlag[cellIndex]){
				returnList = searchPath(cellIndex, endIndex);
				if (returnList.size() > 0)	{
					returnList.addFirst(new Integer(startIndex));
					return returnList;
				}
			}
		}
		
		returnList = new LinkedList();
		return returnList;
	
	}
	
	//*************************************************************
	// According to the path cell determine the vertices of the path
	//*************************************************************
	void findPathPoint(Point2D.Float startLocation,Point2D.Float endLocation)
	{
		GroupVertices.add(startLocation);
		for(int i = 1; i < GroupPath.size(); i++){
			int exitCellIndex = ((Integer)GroupPath.get(i - 1)).intValue();
			int enterCellIndex = ((Integer)GroupPath.get(i)).intValue();
			LinkedList leaveList = cellExitEdge[exitCellIndex];
			for(int j = 0; j < leaveList.size(); j++)	{
				int edgeIndex = ((Integer)leaveList.get(j)).intValue();
				if (enterCellIndex == cellEnter[edgeIndex])	{
					Line2D.Float edge = (Line2D.Float)GroupDivisionEdge.get(edgeIndex);
					Point2D.Float p1 = (Point2D.Float) edge.getP1();
					Point2D.Float p2 = (Point2D.Float) edge.getP2();
					
					float xcenter = (p1.x + p2.x) / 2.0f;
					float ycenter = (p1.y + p2.y) / 2.0f;
					GroupVertices.add(new Point2D.Float(xcenter, ycenter));
					break;
				}
			}
		}// end of for
		GroupVertices.add(endLocation);
	}	
	//********************************************************************************
	// For read in the vertex information
	//********************************************************************************
	public static void fileRead(File file) throws FileNotFoundException, IOException //,NumberFormatException 
	{
		System.out.println("fileRead " + file.getName());// Print out the information
		// Create the input buffer
		BufferedReader 	myInput = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
		// For the input number
		String 			numbers;
		// For temporary data input
		String 			data;
		// For read points
		LinkedList		ReadPoints 	 = new LinkedList(); 	// The read points
		// Clear all the point		
		ReadPoints.clear();
		GroupPoints.clear();
		// Read a line in
		data = myInput.readLine();
		while ( data != null)	{  
			// scan it line by line
			StringTokenizer st = new StringTokenizer(data, "\n");
			// Check whether there are other elements	
			while (st.hasMoreElements()) {
				// Get the next token
				numbers = st.nextToken();
				// Extract a token terminated with " "
				StringTokenizer line = new StringTokenizer(numbers, " ");
				String token = line.nextToken();
				// For vertex information
				if (token.equals("v"))	{
					float x = Float.valueOf(line.nextToken()).floatValue() * 60+200;
					float y = Float.valueOf(line.nextToken()).floatValue() * 60+200;
					float z = Float.valueOf(line.nextToken()).floatValue() * 60+200;
					ReadPoints.add(new Point2D.Float(x, z));
				}
				// For new surface
				else if(token.equals("g"))	{
					token = line.nextToken();
					if(token.equals("default")){
						// There are information inside the Read points and thus it form a group
						if (ReadPoints.size() > 0)	{
							// Add to the groups
							GroupPoints.add(new LinkedList(ReadPoints));
							// Clear the Read Points
							ReadPoints.clear();
						}
					}
				}
			}// end of while st.hasMoreElements
			data = myInput.readLine();
		}// end of while myInput.readLine
		// add the final points into the list		
		if (ReadPoints.size() > 0)	{
			GroupPoints.add(new LinkedList(ReadPoints));
			ReadPoints.clear();
		}
		
		// Print out the input information
		for(int i =0; i < GroupPoints.size(); i++)	{
			LinkedList temp = (LinkedList)GroupPoints.get(i);
			System.out.println(i + "th index " + temp.size());
		}
			
	}// end of fileread

	// This trims (translates) all the points so you can see them on the canvas.
	static void trim(LinkedList list)
	{
	}

	public void calcRectangle()
	{
		// for each line on the convexhull
		// look for the extreme points
		Line2D.Float CHline = new Line2D.Float();
		Line2D.Float CHlinePerpendicular = new Line2D.Float();
		Point2D.Float PerpendicularPoint = new Point2D.Float();

			boundingRectangleArea = (float) (boundingBox.getWidth() * boundingBox.getHeight());
		float distanceFromLine = 0;
		float distanceFromPerpendicularLine = 0;

		float parallelDistance = 0;
		float biggestDFL = 0;
		float biggestDFPL = 0;
		float smallestDFPL =0;

			boolean first = true;

		for(int j=0; j<ConvexHull.size()-1; j++)
		{
			//System.out.println("before loop "+boundingRectangleArea);
			CHline.setLine( (Point2D.Float) ConvexHull.get(j) , (Point2D.Float) ConvexHull.get(j+1) );
			// pick a line that is perpendicular to the line of the convex hull
			PerpendicularPoint.setLocation( -((Point2D.Float) ConvexHull.get(j+1)).y, ((Point2D.Float) ConvexHull.get(j+1)).x);
			CHlinePerpendicular.setLine( (Point2D.Float) ConvexHull.get(j), PerpendicularPoint); 
			// check distance from all those points to the line 
			for(int p=0; p<ConvexHull.size(); p++)
			{
				// all the points are on the left side of this line
				distanceFromLine = (float) CHline.ptLineDist((Point2D.Float) ConvexHull.get(p));
				if(distanceFromLine > biggestDFL)
					biggestDFL = distanceFromLine;
				//System.out.println("what is this? "+boundingRectangleArea);	
				// for the perpendicular line we have to look if the points are on the right or on the left side of the line
				// this can be done by relativeCCW
				distanceFromPerpendicularLine = CHline.relativeCCW((Point2D.Float) ConvexHull.get(p))*(float) CHline.ptLineDist((Point2D.Float) ConvexHull.get(p));
				//System.out.println("distanceFromPerpendicularLine "+distanceFromPerpendicularLine);
				if (distanceFromPerpendicularLine > biggestDFPL)
				{
					biggestDFPL = distanceFromPerpendicularLine;
					//System.out.println("biggestDFPL "+biggestDFPL);	
				}
				if (distanceFromPerpendicularLine < smallestDFPL)
				{
					smallestDFPL = 	distanceFromPerpendicularLine;
					//System.out.println("smallestDFPL" +smallestDFPL);
				}	
				// combine the distances
			}
			parallelDistance = Math.abs(smallestDFPL) + biggestDFPL;
			if(parallelDistance * biggestDFL < boundingRectangleArea)
				boundingRectangleArea = parallelDistance * biggestDFL;	
			//System.out.println("Area of boundingRectangle after algo = "+ boundingRectangleArea);
		}	
	}
}

